config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users

##############################################################################



  #####################
  #####################
  ##   APPLICATION   ##
  #####################
  #####################

  get 'ping' => 'table_tennis#ping'
  get 'ping_api' => 'table_tennis#ping_api'

  get 'help' => 'help#index'

  
  ################
  #   Accueils   #
  ################
  root "home#index"
  get "home", to: "home#index"
  get "admin", to: "home#admin"


  ###################
  #   Maintenances  #
  ###################
  resources :maintenance_ressources
  resources :maintenances
  get "grille_maintenances", to: "maintenances#grille"

  
  #############
  #   Tools   #
  #############
  get "tools", to: "tools#index"
  get "check_days", to: "tools#check_days"
  get "check_users", to: "tools#check_users"
  get "check_admins", to: "tools#check_admins"
  get "backup_db", to: "tools#backup_db"
  get "exports", to: "tools#exports"
  get "download_backup", to: "tools#download_backup"
  get "statistics", to: "tools#statistics"

  get "calculate", to: "tools#calculate"


  ####################
  #   Configuration  #
  ####################
  resources :konfigurations, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##############
  #   Ajouts   #
  ##############
  resources :ajouts, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "ajouts/:id/valider", to: "ajouts#valider"
  get "ajouts/:id/dupliquer", to: "ajouts#dupliquer"
  get "ajouts/:id/modification", to: "ajouts#modification"


  ################
  #   Template   #
  ################
  resources :templates, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ##############
  #   Groupes  #
  ##############
  resources :groupes, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##############
  #   Classes  #
  ##############
  resources :classes, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###############
  #   Services  #
  ###############
  resources :services, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###############
  #   messages  #
  ###############
  resources :messages, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###########
  #  Lieux  #
  ###########
  resources :lieus, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##################
  #  Bug Repports  #
  ##################
  resources :bug_repports, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###################
  #  Blog Messages  #
  ###################
  resources :blog_messages, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  resources :blog_responses, only: [ :new, :edit, :create, :update, :destroy ]
  resources :reviewcats, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  get "blog_message_export_pdf", to: "export#blog_message_export_pdf"
  get "review_blog_message", to: "blog_messages#review"

  ################
  #  Wiki Pages  #
  ################
  resources :wiki_pages, only: [ :show, :index, :new, :edit, :create, :update, :destroy]

  #############
  #  Postits  #
  #############
  resources :postits, only: [ :show, :index, :new, :edit, :create, :update, :destroy]
  get "take_it", to: "postits#take_it"
  get "done", to: "postits#done"

  #####################
  #  Blog Categories  #
  #####################
  resources :blog_categories, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ###################
  #   Utilisateurs  #
  ###################
  resources :utilisateurs, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  #######################
  #  Absences & Congés  #
  #######################
  resources :absences, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "grille", to: "absences#grille"
  get "not_yet_validated_absences", to: "absences#not_yet_validated"
  get "validated_absences", to: "absences#validated"
  get "remove_one_day", to: "absences#remove_one_day"


  ################
  #  Fermetures  #
  ################
  resources :fermetures, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ############
  #  Events  #
  ############
  resources :events, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  ##########
  #  Logs  #
  ##########
  resources :logs, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  resources :log_repports, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]

  
  #####################
  #   Types Absences  #
  #####################
  resources :type_absences, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Jours  #
  ############
  resources :jours, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "today", to: "jours#specific_day"
  get "week", to: "jours#specific_week"
  get "month", to: "jours#specific_month"
  get "secr_pet", to: "jours#secr_pet"
  get "ical_export_ics", to: "export#ical_export_ics"


  ###################
  #   WorkingLists  #
  ###################
  resources :working_lists, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Works  #
  ############
  resources :works, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  

  ############
  #   Tasks  #
  ############
  resources :tasks, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]


  #############
  #   Hebdos  #
  #############
  resources :hebdos, only: [ :show, :index, :new, :edit, :create, :update, :destroy ]
  get "grille_hebdos", to: "hebdos#grille"


  ###################
  #   Productions   #
  ###################
  resources :productions
  resources :prod_units
  resources :prod_destinations
  resources :traceurs


  
  ######## TESTS
  get "show.pdf", to: "export#show"
  get "test", to: "test#index"


  ########## Export DB
  #get "exports", to: "export#index"
  get "logbook_articles_json", to: "export#logbook_articles_json"

end

app/models/wiki_page.rb
class WikiPage < ApplicationRecord
    
    validates :utilisateur_id, :title, :problem_description, :solution_short, presence: true


end

app/controllers/wiki_pages_controller.rb
class WikiPagesController < ApplicationController
    before_action :check_logged_in
    before_action :find_categories
    before_action :find_groupes
    before_action :find_services
    before_action :find_utilisateurs
    before_action :find_wiki_page, only: [:show, :edit, :update, :destroy]
    

    #############
    #   INDEX   #
    #############
    def index
        # Log action
        log(request.path)
        
        @wiki_pages = nil

        # Toutes les entrées...
        @wiki_pages = WikiPage.order(updated_at: :desc).page(params[:page]) if @wiki_pages.nil?
    end


    #############
    #   SHOW    #
    #############
    def show
        # Log action
        log(request.path)
    end


    #############
    #    NEW    #
    #############
    def new
        # Log action
        log(request.path)
        @wiki_page = WikiPage.new
        if params[:blog_message_id]
            @wiki_page.blog_message_id = params[:blog_message_id]
            blog_message = BlogMessage.find(@wiki_page.blog_message_id)
            if blog_message
                @wiki_page.blog_category_id = blog_message.blog_category_id
                @wiki_page.service_id = blog_message.service_id
                @wiki_page.groupe_id = blog_message.groupe
                @wiki_page.keywords = blog_message.keywords
            end
        end
    end


    ##############
    #   CREATE   #
    ##############
    def create
        # Log action
        log(request.path)
        @wiki_page = WikiPage.create(message_params)
        if @wiki_page.save
            flash[:notice] = "Article Wiki créé avec succès"
            redirect_to wiki_pages_path
        else
            render :new
        end
    end

    #############
    #   UPDATE  #
    #############
    def update
        # Log action
        log(request.path, I18n.t("messages.index.log_update"))
        
        if @wiki_page.update(message_params)
            flash[:notice] = "Article wiki modifié avec succès"
            redirect_to wiki_pages_path
        else
            redirect_to :edit
        end
    end


    #############
    #   EDIT    #
    #############
    def edit
        # Log action
        log(request.path, I18n.t("messages.index.log_edit"))
    end


    ##############
    #   DESTROY  #
    ##############
    def destroy
        # Log action
        log(request.path, I18n.t("messages.index.log_destroy"))
        @wiki_page.destroy
    end

    private 

    def message_params
        params.require(:wiki_page).permit(:utilisateur_id, :blog_category_id, :service_id, :groupe_id, :keywords, :title, :problem_description, :solution_short, :solution_long, :blog_message_id)
    end

    def find_wiki_page
        @wiki_page = WikiPage.find(params[:id])
    end

    def find_categories
        @categories = BlogCategory.order(:nom)
        @blog_categories = Hash.new
        @categories.each do |s|
            @blog_categories[s.id] = s.nom
        end
    end

    def find_groupes
        @blog_groupes = Hash.new
        Groupe.all.each do |s|
            @blog_groupes[s.id] = s.nom
        end
    end

    def find_services
        @blog_services = Hash.new
        Service.all.each do |s|
            @blog_services[s.id] = s.nom
        end
    end

    def find_utilisateurs
        @blog_utilisateurs = Hash.new
        Utilisateur.all.each do |s|
            @blog_utilisateurs[s.id] = s.prenom_nom
        end
    end

end

app/views/wiki_pages/_form.html.erb
<%= form_with model: @wiki_page, local: true do |form| %>

    <% if @wiki_page.errors.any? %>
        <strong>WARNING</strong>
        <ul>
            <% @wiki_page.errors.full_messages.each do |message| %>
                <li><%= message %></li>
            <% end %>
        </ul>
    <% end %>

    <!-- Titre -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.title") %>*<br>
        <%= form.text_field :title %>
    </p>

    <!-- Description -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.description") %>*<br>
        <%= form.text_area :problem_description, cols: 80, rows: 3 %>
    </p>

    <!-- Solution Short -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.solution_short") %>*<br>
        <%= form.text_area :solution_short, cols: 80, rows: 3 %>
    </p>

    <!-- Solution long -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.solution_long") %><br>
        <%= form.text_area :solution_long, cols: 80, rows: 15 %>
    </p>

    

    <hr>

    <!-- Blog Message ID -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.blog_message_id") %> : <%= @wiki_page.blog_message_id %><br>
        <%= form.hidden_field :blog_message_id %>
    </p>

    <!-- Utilisateur -->
    <% @wiki_page.utilisateur_id = current_user.utilisateur.id %>
    <p>
        <%= form.label I18n.t("wiki_pages.new.user") %> : <%= @wiki_page.utilisateur_id %><br>
        <%= form.hidden_field :utilisateur_id %>
    </p>

    <!-- Category -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.category") %>
        <%= form.select(:blog_category_id) do %>
            <%= select_option_tag("", nil, @wiki_page.blog_category_id) %>
            <% @categories.each do |l| %>
                <%= select_option_tag(l.nom.capitalize, l.id, @wiki_page.blog_category_id) %>
            <% end %>
        <% end %>
    </p>

    <!-- Service -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.service") %>
        <%= form.select(:service_id) do %>
            <%= select_option_tag("", nil, @wiki_page.service_id) %>
            <% services = Service.order(:nom) %>
            <% services.find_each do |l| %>
                <%= select_option_tag(l.nom.capitalize, l.id, @wiki_page.service_id) %>
            <% end %>
        <% end %>
    </p>
    
    <!-- Groupe -->
    <p>
        <%= form.label I18n.t("wiki_pages.new.groupe") %>
        <%= form.select(:groupe_id) do %>
            <%= select_option_tag("", nil, @wiki_page.groupe_id) %>
            <% groupes = Groupe.order(:nom) %>
            <% groupes.find_each do |l| %>
                <%= select_option_tag(l.nom.capitalize, l.id, @wiki_page.groupe_id) %>
            <% end %>
        <% end %>
    </p>
    

    <!-- Submit -->
    <p>
        <%= form.submit class: "btn btn-primary" %>
    </p>
<% end %>

app/views/wiki_pages/_wiki_page.html.erb
    <div class="col-sm-4" id="wiki_page_<%= wiki_page.id %>">
        <div class="panel panel-info">

            <div class="panel-heading">
                <%= link_to wiki_page.title, wiki_page_path(wiki_page) %>
                
                <% unless wiki_page.service_id.nil? %>
                    &nbsp;&nbsp;&nbsp;
                    <span class="label label-info">
                        <%= @blog_services[wiki_page.service_id]  %>
                    </span>
                <% end %>
            </div>

            <div class="panel-body">
                <%= wiki_page.problem_description.truncate(80) %>
                <hr>
                <span class="label label-default"><%= @blog_groupes[wiki_page.groupe_id] unless wiki_page.groupe_id.nil? %></span>&nbsp;
                <span class="label label-default"><%= @blog_categories[wiki_page.blog_category_id] unless wiki_page.blog_category_id.nil? %></span>&nbsp;
            
            </div>

        </div>
    </div>

app/views/wiki_pages/_wiki_pages.html.erb
<div class="container">
    <p><%= paginate @wiki_pages, remote: true %></p>
    <div class="row" ><%= render @wiki_pages %></div>
    <p><%= paginate @wiki_pages, remote: true %></p>
</div>

app/views/wiki_pages/destroy.js.erb
$("#wiki_page_<%= @wiki_page.id %>").remove();

app/views/wiki_pages/edit.html.erb
<div class="page-header">
<h1>
    <span class="label label-primary">
        <i class="material-icons">account_tree</i>
        <%= I18n.t("wiki_pages.index.title").upcase %>
    </span>
</h1>
</div>
<div class="container">
    <%= render "form" %>
</div>

app/views/wiki_pages/index.html.erb
<% session[:page_aide] = "wiki_pages" %>

<div class="page-header">
    <h1>
        <span class="label label-primary">
            <i class="material-icons">account_tree</i>
            <%= I18n.t("wiki_pages.index.wiki").upcase %>
        </span>
    </h1>
</div>

<div class="container">

    <p>
        <%= link_to '<i class="material-icons">note_add</i> '.html_safe, 
                new_wiki_page_path,
                class: "btn btn-success btn-xs" %>
    </p>

    <div id="wiki_pages">
        <%= render 'wiki_pages' %>
    </div>

</div>

app/views/wiki_pages/index.js.erb
$("#wiki_pages").html("<%= j render "wiki_pages" %>");

app/views/wiki_pages/new.html.erb
<div class="page-header">
<h1>
    <span class="label label-primary">
        <i class="material-icons">account_tree</i>
        <%= I18n.t("wiki_pages.index.wiki").upcase %>
    </span>
</h1>
</div>
<div class="container">
    <h3>
        <span class="label label-info">
            <%= I18n.t("wiki_pages.new.title").capitalize %>
        </span>
    </h3>
    
    <%= render "form" %>
</div>

app/views/wiki_pages/show.html.erb
<div class="page-header">
    <h1>
        <span class="label label-primary">
            <i class="material-icons">account_tree</i>
            <%= I18n.t("wiki_pages.index.wiki").upcase %>
        </span>
    </h1>
</div>

<div class="container">

    <h2><span class="label label-info"><%= @wiki_page.title.capitalize %> </span></h2>

    <h3><span class="label label-warning"><%= I18n.t("wiki_pages.show.problem").capitalize %></span></h3>
    <p><%= @wiki_page.problem_description %></p>

    <h3><span class="label label-success"><%= I18n.t("wiki_pages.show.solution").capitalize %></span></h3>
    <p><%= @wiki_page.solution_short %></p>

    <hr>
    <div class="row">
        
        <div class="col-sm-3">
            <span class="label label-default">References</span><br>
            <small>
                (Update: <%= I18n.localize @wiki_page.updated_at, format: :long %> by <%= @blog_utilisateurs[@wiki_page.utilisateur_id] %>)
            </small>
        </div>

        <div class="col-sm-3">
            Service: <% unless @wiki_page.service_id.nil? %>
                    [<%= @blog_services[@wiki_page.service_id] %>]
                <% else %>
                    - - -
                <% end %><br>

            Groupe: <% unless @wiki_page.groupe_id.nil? %>
                    [<%= @blog_groupes[@wiki_page.groupe_id] %>]
                <% else %>
                    - - -
                <% end %><br>

            Category: <%= @blog_categories[@wiki_page.blog_category_id] unless @wiki_page.blog_category_id.nil? %>
            
        </div>
        
        <div class="col-sm-3">
            <%= "Keywords: [#{@wiki_page.keywords}]" unless @wiki_page.keywords.nil? %>
        </div>

        <div class="col-sm-3">
            <% unless @wiki_page.blog_message_id.nil? %>
                <a href="<%= blog_message_path(@wiki_page.blog_message_id) %>" class="btn btn-xs btn-default" role="button">See Blog Article</a>
            <% end %>
        </div>

    </div>
    <hr>

    <h4><span class="label label-primary"><%= I18n.t("wiki_pages.show.detailed_solution").upcase %></span></h4>
    <p><%= @wiki_page.solution_long %></p>

    <hr>

    <a href="<%= wiki_pages_path %>" class="btn btn-xs btn-info" role="button"> << Back to WikiPages </a>
    <a href="<%= edit_wiki_page_path(@wiki_page) %>" class="btn btn-xs btn-default" role="button">Edit this Article</a>
    
</div>